//============================================================================
// Name        : HuffmanCoder.cpp
// Author      : Ruediger Knoerig
// Version     :
// Copyright   : GPL
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <itpp/base/random.h>
#include "HuffmanCoder.h"

using namespace std;
using namespace itpp;

int main() {
	//unsigned int data[]={0,1,2,2,3,1,2,2};
	//Vec<unsigned int> x(data,8);
	//cout << "Input data: " << x << endl;
	unsigned int N=100000;
	Laplace_RNG stat;
	vec xf=stat(N);
	Vec<unsigned int> x(N);
	const int m=1;
	const int Nbit=(1<<m);
	for(unsigned int k=0;k<N;k++)
		{
			double val = (xf(k)+0.5)*Nbit;
			if(val < 0.0) val=0.0;
			if(val >= 2*Nbit) val=2*Nbit-1;
			x(k)=(unsigned int) val;
		}

	HuffmanCoder hcoder(m+1);
	double mcl = hcoder.train(x);
	cout << "Got a " << (hcoder.isTrained() ? "trained" : "untrained") << " and "
	<< (hcoder.isInitialized() ? "initialized" : "uninitialized")
	<< " huffman coder with an input range of [0.." << hcoder.getN()-1 << "]." << endl;
	//cout << endl << " x\t|\thuffmancode(x)" << endl;
	//for(int k=0;k<x.length();k++) cout << x(k) << "\t|\t" << hcoder.code(x(k)) << endl;
	bvec coded = hcoder.code(x);
	Vec<unsigned int> xr=hcoder.decode(coded);
	cout << endl;
	// cout << "Vector x kodiert: " << coded << endl;
	cout << "Mean code length: " << mcl << endl
		<< "Mean number of bits/ symbol in example: " << double(coded.length())/N << endl
		<< "Code table: " << hcoder.getCodeTable() << endl
		<< "Decode table: " << hcoder.getDecodeTable() << endl
		//<< "Decoded: " << xr << endl
		<< ((xr==x) ? "bereinstimmung xr mit x" : "Xr stimmt nicht mit x berein!") << endl;
}
